import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import React from "react";
import { BrowserRouter } from "react-router-dom";
import { RuntimeContext, initialRuntime, normalizeApp } from "./RuntimeContext";
import RuntimePage from "./RuntimePage";
import { exposeGlobalRuntime } from "./utils/exposeGlobalRuntime";
const ClientRuntime = ({ basename, schema }) => {
    React.useEffect(exposeGlobalRuntime, []);
    const value = React.useMemo(() => (Object.assign(Object.assign({}, initialRuntime), { app: normalizeApp(schema) })), [schema]);
    return (_jsx(BrowserRouter, Object.assign({ basename: basename }, { children: _jsx(RuntimeContext.Provider, Object.assign({ value: value }, { children: _jsx(RuntimePage, {}) })) })));
};
export { exposeGlobalRuntime };
export default ClientRuntime;
//# sourceMappingURL=ClientRuntime.js.map