import { registerComponent } from "../interfaces";
import { inputFieldPrefix, RuntimeInputContext } from "../RuntimeInput";
import React from "react";
const Role = registerComponent("Role", {
    type: "none",
    icon: "Pencil",
    group: "input",
    defaultProps: {
        roleId: "",
    },
    propDefinition: {
        roleId: {
            type: "role",
            options: {},
        },
    },
    Component: (props) => {
        const roleId = props.properties.roleId;
        const actions = RuntimeInputContext.useActions();
        React.useEffect(() => {
            actions.handleChange(inputFieldPrefix + "role", roleId);
        }, [actions, roleId]);
        return null;
    },
});
export default Role;
//# sourceMappingURL=buildRole.js.map