import { extendTheme } from "@chakra-ui/react";
import { registerTheme } from ".";
import { getShades } from "./shadeCalculator";
export default registerTheme("Light", extendTheme({
    colors: {
        auto: getShades("#FFFFFF"),
        bg: getShades("#F4F4F4"),
        text: getShades("#5C5C5C"),
        surface: getShades("#FFFFFF"),
        brand: getShades("#0540F2"),
        error: getShades("#E03138"),
        success: getShades("#329922"),
        info: getShades("#056CF2"),
        warning: getShades("#EE7105"),
    },
    fonts: {
        body: "system-ui, sans-serif",
        heading: "system-ui, sans-serif",
    },
    config: { initialColorMode: "light", useSystemColorMode: false },
    styles: { global: { bg: "qore.bg_light", color: "#1F1F1F" } },
    components: {
        Box: {
            baseStyle: { bg: "F6F6F6" },
        },
        Text: {
            baseStyle: {
                color: "#001E4D",
            },
        },
        Card: {
            baseStyle: { bg: "FFFFFF" },
        },
        Button: {
            baseStyle: {
                color: "#FFFFFF",
                borderRadius: "8px",
            },
            variants: {
                ghost: {
                    bg: "qore.primary_lightest",
                    color: "qore.primary",
                    _hover: { bg: "qore.primary_lightest" },
                    _active: { bg: "qore.primary_lightest" },
                },
                solid: {
                    bg: "qore.primary",
                    _hover: { bg: "qore.primary" },
                    _active: { bg: "qore.primary" },
                },
            },
        },
    },
}));
//# sourceMappingURL=light.js.map