import { filtrexToFormula } from "./filtrexToFormula";
describe("Convert Filtrex To Formula", () => {
    it("should convert react-mentions to formula", () => {
        expect(filtrexToFormula("@[user.name](user.name)")).toEqual(`"{{user.name}}"`);
    });
    it("should convert filtrex expression to formula", () => {
        expect(filtrexToFormula('="Rp" + format_currency(10000, ",")')).toEqual(`Filtrex("\\"Rp\\" + format_currency(10000, \\",\\")")`);
    });
    it("should convert filtrex expression with react-mentions to formula", () => {
        expect(filtrexToFormula('=date_format("DD MM YYYY", @[date](date))')).toEqual(`Filtrex("date_format(\\"DD MM YYYY\\", {{date}})")`);
    });
});
//# sourceMappingURL=filtrexToFormula.spec.js.map