import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import React from "react";
import { Accordion, AccordionButton, AccordionIcon, AccordionItem, AccordionPanel, Box, SimpleGrid, } from "@chakra-ui/react";
import { componentGroups, getGroupedComponentList, } from "@qorebase/app-runtime/src/interfaces";
import { RuntimeContext } from "@qorebase/app-runtime/src/RuntimeContext";
import ComponentHandle from "./ComponentHandle";
const LibraryPanel = () => {
    const npmComponents = RuntimeContext.useSelectState((state) => state.app.components);
    const groupedComponentList = React.useMemo(getGroupedComponentList, [
        npmComponents,
    ]);
    return (_jsx(Box, Object.assign({ pb: "96", minH: "full", bg: "#f5f5f5" }, { children: _jsx(Accordion, Object.assign({ allowMultiple: true, defaultIndex: componentGroups.map((_, idx) => idx) }, { children: componentGroups.map((group, i) => {
                var _a;
                return (_jsxs(AccordionItem, { children: [_jsx("h2", { children: _jsxs(AccordionButton, Object.assign({ bg: "white", _hover: {
                                    bg: "whiteAlpha.700",
                                }, _expanded: {
                                    borderBottom: "1px solid",
                                    borderColor: "gray.200",
                                } }, { children: [_jsx(Box, Object.assign({ flex: "1", textAlign: "left", textTransform: "capitalize", fontWeight: "bold" }, { children: group })), _jsx(AccordionIcon, {})] })) }), _jsx(AccordionPanel, Object.assign({ pb: 4 }, { children: _jsx(SimpleGrid, Object.assign({ columns: 2, gap: "2" }, { children: (_a = groupedComponentList[group]) === null || _a === void 0 ? void 0 : _a.map((component) => (_jsx(ComponentHandle, { component: component }, component.id))) })) }))] }, i));
            }) })) })));
};
export default LibraryPanel;
//# sourceMappingURL=LibraryPanel.js.map