import { QoreClient } from "@qorebase/client";
import createQoreContext from "@qorebase/react";
import Cookies from "js-cookie";
const isServer = typeof window === "undefined";
const BASE_URL = process.env.NODE_ENV === "development" && !isServer
    ? "/api/backend"
    : process.env.NEXT_PUBLIC_QORE_DATA_CONSOLE_ENDPOINT;
export const qoreConfig = {
    endpoint: BASE_URL,
    adminSecret: process.env.QORE_DATA_CONSOLE_ADMIN_SECRET,
    getToken: () => Cookies.get("token"),
};
const client = new QoreClient(qoreConfig);
client.project.axios.defaults.headers["x-qore-engine-admin-secret"] =
    qoreConfig.adminSecret;
const qoreStorageClient = createQoreContext(client);
export default qoreStorageClient;
//# sourceMappingURL=qoreStorageClient.js.map