import React from "react";
import { RuntimeContext } from "@qorebase/app-runtime/src/RuntimeContext";
export const useSourceView = () => {
    const tables = RuntimeContext.useSelectState((state) => state.app.schema.tables);
    const views = RuntimeContext.useSelectState((state) => state.app.schema.views);
    const page = RuntimeContext.useSelectState((state) => state.app.maps.page[state.control.page]);
    const sourceView = React.useMemo(() => {
        return (tables.find((table) => table.name === (page === null || page === void 0 ? void 0 : page.sourceID)) ||
            views.find((view) => view.name === (page === null || page === void 0 ? void 0 : page.sourceID)));
    }, [tables, views, page]);
    return sourceView;
};
//# sourceMappingURL=useSourceView.js.map