import { __awaiter } from "tslib";
import Cloudflare from "cloudflare";
const cloudflare = new Cloudflare({ token: process.env.CLOUFLARE_TOKEN });
export default function handler(req, res) {
    return __awaiter(this, void 0, void 0, function* () {
        const { address } = req.body;
        // eslint-disable-next-line @typescript-eslint/no-unused-vars -- might use the response later
        const response = yield cloudflare.dnsRecords.add(process.env.CLOUDFLARE_ZONE_ID || "", {
            content: process.env.CLOUDFLARE_RECORD_IP || "",
            // name: address + process.env.NEXT_PUBLIC_APPS_DOMAIN,
            name: address + "-apps",
            ttl: 3600,
            proxied: true,
            type: "A",
        });
        res.status(200).json({ status: "ok" });
    });
}
//# sourceMappingURL=add-domain.js.map